#!/usr/bin/env sh

function check_result {
  if [ "0" -ne "$?" ]
  then
    echo $1
    exit 1
  fi
}

function unload_kext {
  echo Testing $1
  LOADED=$(kextstat | grep $1)
  if [ ! -z "$LOADED" ]
  then
    echo Unloading $1
    kextunload -b $1
  fi
}

if [ "$UID" -ne "0" ]
then
  echo Must be run as root.
  echo $UID
  exit 1
fi

DIR=$(dirname $0)

PREBUILT=$DIR/../darwin

echo Unloading existing tun/tap kexts.
unload_kext net.tunnelblick.tun
unload_kext net.tunnelblick.tap
unload_kext com.viscosityvpn.Viscosity.tun
unload_kext com.viscosityvpn.Viscosity.tap
echo Done unloading tun/tap kexts.


KEXT=$PREBUILT/tun.kext
rm -rf /tmp/tun.kext
cp -R $KEXT /tmp
KEXT=/tmp/tun.kext
chown -R root:wheel $KEXT
chmod -R o-w,g-w $KEXT
echo Loading $KEXT.
kextload $KEXT
check_result "Error loading $KEXT"

echo Starting Tether...
cd $DIR/../node-tuntap
$PREBUILT/adb start-server
$PREBUILT/node tether.js
